package maze.model;

// Students given MoveTest, but implement complete file.

public enum Move {
	FORWARD {
		@Override
		public Position newPosition(Position p, Direction d) {
			return d.getNeighbor(p);
		}

		@Override
		public Direction newDirection(Direction d) {
			return d;
		}
	},
	LEFT {
		@Override
		public Position newPosition(Position p, Direction d) {
			return p;
		}

		@Override
		public Direction newDirection(Direction d) {
			return d.getCounterclockwise();
		}
	},
	RIGHT {
		@Override
		public Position newPosition(Position p, Direction d) {
			return p;
		}

		@Override
		public Direction newDirection(Direction d) {
			return d.getClockwise();
		}
	};
	
	abstract public Position newPosition(Position p, Direction d);
	abstract public Direction newDirection(Direction d);
}
